.\" $XFree86: xc/doc/man/DMX/DMX.man,v 1.1 2004/06/30 20:21:36 martin Exp $
.\"
.\" Copyright 2004 Red Hat Inc., Durham, North Carolina.
.\" All Rights Reserved.
.\"
.\" Permission is hereby granted, free of charge, to any person obtaining
.\" a copy of this software and associated documentation files (the
.\" "Software"), to deal in the Software without restriction, including
.\" without limitation on the rights to use, copy, modify, merge,
.\" publish, distribute, sublicense, and/or sell copies of the Software,
.\" and to permit persons to whom the Software is furnished to do so,
.\" subject to the following conditions:
.\"
.\" he above copyright notice and this permission notice (including the
.\" next paragraph) shall be included in all copies or substantial
.\" portions of the Software.
.\"
.\" THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
.\" EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
.\" MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
.\" NON-INFRINGEMENT.  IN NO EVENT SHALL RED HAT AND/OR THEIR SUPPLIERS
.\" BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
.\" ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
.\" CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
.\" SOFTWARE.
.TH DMX 3X __vendorversion__
.SH NAME
DMX \- X Window System DMX (Distributed Multihead X) extension
.SH DESCRIPTION
The DMX extension provides support for communication with and control of
.BR Xdmx (1)
server.  Attributes of the
.BR Xdmx (1)
server and of the back-end screens attached to the server can be queried
and modified via this protocol.
.SH "SUMMARY OF LIBRARY FUNCTIONS"
The following is a summary of DMX library functions:
.sp
DMXQueryExtension(3X) \- determine if DMX is available
.sp
DMXQueryVersion(3X) \- determine DMX extension version
.sp
DMXSync(3X) \- flush protocol requests between
.BR Xdmx (1)
and back-end X servers
.sp
DMXForceWindowCreation(3X) \- force immediate back-end window creation
.sp
DMXGetScreenCount(3X) \- determine number of back-end screens
.sp
DMXGetScreenAttributes(3X) \- determine back-end screen attributes
.sp
DMXChangeScreensAttributes(3X) \- change back-end screen attributes
.sp
DMXAddScreen(3X) \- attach a new back-end screen
.sp
DMXRemoveScreen(3X) \- detach a back-end screen
.sp
DMXGetWindowAttributes(3X) \- determine back-end window attributes
.sp
DMXGetDesktopAttributes(3X) \- determine global bounding box
.sp
DMXChangeDesktopAttributes(3X) \- change global bounding box
.sp
DMXGetInputCount(3X) \- determine number of input devices
.sp
DMXGetInputAttributes(3X) \- determine input device attributes
.sp
DMXAddInput(3X) \- attach a new backend or console input
.sp
DMXRemoveInput(3X) \- detach an input
.sp
DMXAddBackendInput(3X) \- attach a new back-end input
.sp
DMXAddConsoleInput(3X) \- attach a new console input
.PP
Each of these functions is described in its own man page.
.SH "SEE ALSO"
.BR Xdmx "(1), " xdmxconfig "(1), " vdltodmx (1)
