<html>
  <head>
    <title>XFree86(TM): Documentation: Specification Documents</title>
    <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
<style type="text/css">
 body {
  background-color: efefef;
  color: black;
 }
 a:link { color: blue }
 a:visited { color: #551a8b }
 a:active { color: red }
</style>
  </head>

  <body>
  <h2>XFree86&trade; Documentation: Specification and Related Documents</h2>

  <p><i>The formatting of some of the HTML versions of these documents may
  have some problems.  In such cases refer to the PDF versions.</i></p>

  <h3>Core and Extension Protocols</h3>

  <ul>
    <li><a href="proto.html">Core X Protocol</a> <a href="../PDF/proto.pdf">[PDF]</a></li>
    <li><a href="xlib.html">Core X Protocol Library API</a> <a href="../PDF/xlib.pdf">[PDF]</a></li>
    <li><a href="mit-shm.html">MIT-SHM (shared memory) Extension</a> <a href="../PDF/mit-shm.pdf">[PDF]</a></li>
    <li><a href="xc-misc.html">XC-MISC Extension</a> <a href="../PDF/xc-misc.pdf">[PDF]</a></li>
    <li><a href="bigreq.html">BIGREQ (Big Requests) Extension</a> <a href="../PDF/bigreq.pdf">[PDF]</a></li>
    <li><a href="shape.html">Shape (non-rectangular window) Extension Protocol</a> <a href="../PDF/shape.pdf">[PDF]</a></li>
    <li><a href="shapelib.html">Shape (non-rectangular window) Extension Library API</a> <a href="../PDF/shapelib.pdf">[PDF]</a></li>
    <li><a href="appgroup.html">XC-APPGROUP (Application Group) Extension</a> <a href="../PDF/appgroup.pdf">[PDF]</a></li>
    <li>Security Extension <a href="../PDF/security.pdf">[PDF]</a></li>
    <li><a href="tog-cup.html">TOG CUP (Colormap Utilization Policy) Extension</a> <a href="../PDF/tog-cup.pdf">[PDF]</a></li>
    <li><a href="DPMS.html">DPMS (Display Power Management Signaling) extension protocol</a> <a href="../PDF/DPMS.pdf">[PDF]</a></li>
    <li><a href="DPMSLib.html">DPMS (Display Power Management Signaling) Extension Client Library API</a> <a href="../PDF/DPMSLib.pdf">[PDF]</a></li>
    <li><a href="evi.html">EVI (Extended Visual Information) Extension</a> <a href="../PDF/evi.pdf">[PDF]</a></li>
    <li><a href="XiProtocol.html">Xi (X Input) Extension Protocol</a> <a href="../PDF/XiProtocol.pdf">[PDF]</a></li>
    <li><a href="XiLib.html">Xi (X Input) Extension Library API</a> <a href="../PDF/XiLib.pdf">[PDF]</a></li>
    <li><a href="XiPorting.html">Xi (X Input) Porting Information</a> <a href="../PDF/XiPorting.pdf">[PDF]</a></li>
    <li><a href="buffer.html">Multi-buffer Extension (obsolete)</a> <a href="../PDF/buffer.pdf">[PDF]</a></li>
    <li>Double Buffer Extension Protocol <a href="../PDF/dbe.pdf">[PDF]</a></li>
    <li>Double Buffer Extension Library API <a href="../PDF/dbelib.pdf">[PDF]</a></li>
    <li><a href="record.html">Record Extension Protocol</a> <a href="../PDF/record.pdf">[PDF]</a></li>
    <li><a href="recordlib.html">Record Extension Library API</a> <a href="../PDF/recordlib.pdf">[PDF]</a></li>
    <li><a href="xtest.html">XTEST Extension Protocol</a> <a href="../PDF/xtest.pdf">[PDF]</a></li>
    <li><a href="xtestlib.html">XTEST Extension Library API</a> <a href="../PDF/xtestlib.pdf">[PDF]</a></li>
    <li>Synchronization Extension Protocol <a href="../PDF/sync.pdf">[PDF]</a></li>
    <li>Synchronization Extension Library API <a href="../PDF/synclib.pdf">[PDF]</a></li>
    <li>XPrint Extension Protocol <a href="../PDF/xp_proto.pdf">[PDF]</a></li>
    <li>XPrint Extension Library API <a href="../PDF/xp_library.pdf">[PDF]</a></li>
    <li>XKEYBOARD Extension Protocol <a href="../PDF/XKBproto.pdf">[PDF]</a></li>
    <li>XKEYBOARD Extension Library API <a href="../PDF/XKBlib.pdf">[PDF]</a></li>
  </ul>

  <h3>Other Protocols and Interfaces</h3>
  <ul>
    <li><a href="Xtrans.html">X Transport Interface</a> <a href="../PDF/Xtrans.pdf">[PDF]</a></li>
    <li><a href="xdmcp.html">XDMCP (X Display Manager Control Protocol)</a> <a href="../PDF/xdmcp.pdf">[PDF]</a></li>
    <li><a href="fsproto.html">Font Server Protocol</a> <a href="../PDF/fsproto.pdf">[PDF]</a></li>
    <li><a href="xim.html">XIM (X Input Method) Protocol</a> <a href="../PDF/xim.pdf">[PDF]</a></li>
    <li><a href="XIMTransport.html">XIM Transport</a> <a href="../PDF/XIMTransport.pdf">[PDF]</a></li>
#ifdef ICE_PDF_ONLY
    <li>ICE (Inter-Client Exchange) Protocol <a href="../PDF/ice.pdf">[PDF]</a></li>
    <li>ICE (Inter-Client Exchange) Library API <a href="../PDF/ICElib.pdf">[PDF]</a></li>
#else
    <li><a href="ice.html">ICE (Inter-Client Exchange) Protocol</a> <a href="../PDF/ice.pdf">[PDF]</a></li>
    <li><a href="ICElib.html">ICE (Inter-Client Exchange) Library API</a> <a href="../PDF/ICElib.pdf">[PDF]</a></li>
#endif
#ifdef ICCCM_PDF_ONLY
    <li>ICCCM (Inter-Client Communcations Conventions Manual) <a href="../PDF/icccm.pdf">[PDF]</a></li>
#else
    <li><a href="icccm.html">ICCCM (Inter-Client Communcations Conventions Manual)</a> <a href="../PDF/icccm.pdf">[PDF]</a></li>
#endif
    <li><a href="xsmp.html">SM (X Session Managemenet) Protocol</a> <a href="../PDF/xsmp.pdf">[PDF]</a></li>
    <li><a href="SMlib.html">SM (X Session Management) Library API</a> <a href="../PDF/SMlib.pdf">[PDF]</a></li>
  </ul>

  <h3>Internationalization</h3>
  <ul>
    <li><a href="i18nFramework.html">I18N Framework</a> <a href="../PDF/i18nFramework.pdf">[PDF]</a></li>
  </ul>

  <h3>Client Libraries</h3>

  <ul>
    <li><a href="widgets.html">Athena Widgets (Xaw)</a> <a href="../PDF/widgets.pdf">[PDF]</a></li>
    <li><a href="fontlib.html">X Font Library (fontlib)</a> <a href="../PDF/fontlib.pdf">[PDF]</a></li>
    <li><a href="xmu.html">Xmu Library</a> <a href="../PDF/xmu.pdf">[PDF]</a></li>
    <li><a href="intrinsics.html">X Toolkit Intrinsics (Xt)</a> <a href="../PDF/intrinsics.pdf">[PDF]</a></li>
    <li>XPM (X Pixmap) Library <a href="../PDF/xpm.pdf">[PDF]</a></li>
  </ul>

  <h3>Formats and Encodings</h3>

  <ul>
    <li><a href="bdf.html">BDF (Bitmap Distribution Format) Font Format</a> <a href="../PDF/bdf.pdf">[PDF]</a></li>
    <li><a href="ctext.html">CTEXT (Compound Text) Encoding</a> <a href="../PDF/ctext.pdf">[PDF]</a></li>
    <li><a href="LocaleDB.html">X Locale Database Definition</a> <a href="../PDF/LocaleDB.pdf">[PDF]</a></li>
    <li><a href="xlfd.html">XLFD (X Logical Font Description) Conventions</a> <a href="../PDF/xlfd.pdf">[PDF]</a></li>
    <li>The RX Document (describes the RX MIME type) <a href="../PDF/RX.pdf">[PDF]</a></li>
  </ul>

  <h3>Implementation and Design</h3>

  <ul>
    <li><a href="ddx.html">XServer DDX</a> <a href="../PDF/ddx.pdf">[PDF]</a></li>
    <li>Security Extension Server Design <a href="../PDF/secint.pdf">[PDF]</a></li>
    <li>Analysis of the X Protocol for Security Concerns <a href="../PDF/analysis.pdf">[PDF]</a></li>
    <li><a href="xfs-design.html">Font Server Design</a> <a href="../PDF/xfs-design.pdf">[PDF]</a></li>
  </ul>

  <h3>Xtest Suite</h3>

  <ul>
    <li>Xtest User Guide <a href="../PDF/xtest-userguide.pdf">[PDF]</a></li>
    <li>Xtest Programmers Guide <a href="../PDF/xtest-progguide.pdf">[PDF]</a></li>
    <li>Xtest Release Notes <a href="../PDF/xtest-relnotes.pdf">[PDF]</a></li>
  </ul>

  <h3>Miscellaneous</h3>

  <ul>
    <li><a href="rstart.html">rstart</a> <a href="../PDF/rstart.pdf">[PDF]</a></li>
    <li><a href="ctlseqs.html">Xterm control sequences</a> <a href="../PDF/ctlseqs.pdf">[PDF]</a></li>
  </ul>

  <!-- $XFree86: xc/doc/specs/specindex.cpp,v 1.2 2005/03/12 23:54:51 dawes Exp $ -->
</body>
</html>
 
