.\" $XFree86: xc/programs/Xserver/hw/xfree86/drivers/via/via.man,v 1.6 2005/02/01 02:25:08 dawes Exp $
.\" shorthand for double quote that works everywhere.
.ds q \N'34'
.TH VIA __drivermansuffix__ __vendorversion__
.SH NAME
via \- VIA video driver
.SH SYNOPSIS
.nf
.B "Section \*qDevice\*q"
.BI "  Identifier \*q"  devname \*q
.B  "  Driver \*qvia\*q"
\ \ ...
.B EndSection
.fi
.SH DESCRIPTION
.B via
is an XFree86 driver for VIA video chipsets.
.PP
The
.B via
driver supports the VIA CLE266 (CLE3122, CLE3022) chipset video and the
VIA KM400/K8M800 VT3204/5/7204/5 video, including 2D acceleration and the Xv 
video overlay extensions. Flat panel, TV and VGA outputs are supported.
.PP
Direct rendering 3D is available for this device only using XFree86 4.2 
builds. If you are interested in porting the DRI support to current XFree86
then please see the DRI project on sourceforge.net.
.PP
.SH CONFIGURATION DETAILS
Please refer to XF86Config(__filemansuffix__) for general configuration
details.  This section only covers configuration details specific to this
driver.
.PP
The following driver
.B Options
are supported:
.TP
.BI "Option \*qNoAccel\*q \*q" boolean \*q
Disable or enable acceleration. Default: acceleration is enabled.
.TP
.BI "Option \*qHWCursor\*q \*q" boolean \*q
Disable or enable use of hardware cursors. The default is enabled.
.TP
.BI "Option \*qSWCursor\*q \*q" boolean \*q
Disable or enable the use of a software cursor. The default is disabled.
.TP
.BI "Option \*qShadowFB\*q \*q" boolean \*q
Use a shadow frame buffer. This is required when rotating the display,
but otherwise defaults to disabled.
.TP
.BI "Option \*qUseBIOS\*q \*q" boolean \*q
Use the video BIOS to set modes. Default false.
.TP
.BI "Option \*qVideoRAM\*q \*q" boolean \*q
Override the VideoRAM auto detection. This should never be needed.
.TP
.BI "Option \*qRotate\*q \*q" string \*q
Rotate the display either clockwise ("CW") or counter clockwise ("CCW").
Rotation is only supported unaccelerated.
.TP
.BI "Option \*qActiveDevice\*q \*q" string \*q
Specify the active device combination. The choices are "CRT,TV",
"CRT,LCD", "CRT,DFP", "TV,DFP", "CRT", "LCD", or "DFP", for the various
supported combinations of VGA CRT output, LCD panel output, DFP output and
TV output.
.TP
.BI "Option \*qLCDDualEdge\*q \*q" boolean \*q
Use dual edge mode to set the LCD.
.TP
.BI "Option \*qCenter\*q \*q" boolean \*q
Disable or enable image centering on DVI displays.
.TP
.BI "Option \*qPanelSize\*q \*q" string \*q
Specify the size (width x height) of the LCD panel attached to the
system. Sizes 640x480, 800x600, 1024x768, 1280x1024, and 1400x1050
are supported.
.TP
.BI "Option \*qTVDotCrawl\*q \*q" boolean \*q
Disable or enable dotcrawl.
.TP
.BI "Option \*qTVType\*q \*q" string \*q
Specify TV output format. The driver currently supports NTSC and
PAL timings only.
.TP
.BI "Option \*qTVOutput\*q \*q" string \*q
Specify which TV output to use. The driver supports "S-Video", "Composite",
"SC", "RGB" and "YCbCr" outputs. Note that on many boards the composite
video port is shared with audio out and jumper selected.
.TP
.BI "Option \*qTVVScan\*q \*q" string \*q
Specify whether to underscan the TV image (bordering it with black), or
overscan it (losing the edges of the picture).
.TP
.BI "Option \*qTVHScale\*q \*q" string \*q
Not yet implemented.
.TP
.BI "Option \*qTVEncoder\*q \*q" string \*q
Specify which TV encoder chip is attached to the system. The driver
currently supports the VT1621 and VT1622 encoders.
.TP
.BI "Option \*qRefresh\*q \*q" integer \*q
Specify the desired refresh.
.TP
.BI "Option \*qDisableVQ\*q \*q" boolean \*q
Disable or enable the use of VQ. VQ is enabled by default.
.TP
.BI "Option \*qCap0Deinterlace\*q \*q" string \*q
Set the capture 0 port interlace mode to either Bob or Weave.
.TP
.BI "Option \*qCap1Deinterlace\*q \*q" string \*q
Set the capture 1 port interlace mode to either Bob or Weave.
.TP
.BI "Option \*qCap0FieldSwap\*q \*q" string \*q
Perform field swapping on capture port 0.
.TP
.BI "Option \*qDRIXINERAMA\*q \*q" boolean \*q
Set DRI Xinerama mode. Currently unsupported.
.SH "SEE ALSO"
XFree86(1), XF86Config(__filemansuffix__), xf86config(1), Xserver(1), X(__miscmansuffix__)
.SH AUTHORS
Authors include: ...
