.\" Copyright 1994, 1998  The Open Group
.\" 
.\" Permission to use, copy, modify, distribute, and sell this software and its
.\" documentation for any purpose is hereby granted without fee, provided that
.\" the above copyright notice appear in all copies and that both that
.\" copyright notice and this permission notice appear in supporting
.\" documentation.
.\" 
.\" The above copyright notice and this permission notice shall be included in
.\" all copies or substantial portions of the Software.
.\" 
.\" THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
.\" IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
.\" FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL 
.\" THE OPEN GROUP BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, 
.\" WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF 
.\" OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE 
.\" SOFTWARE.
.\" 
.\" Except as contained in this notice, the name of The Open Group shall not 
.\" be used in advertising or otherwise to promote the sale, use or other 
.\" dealing in this Software without prior written authorization from the 
.\" The Open Group.
.\"
.\" $XFree86: xc/programs/scripts/xon.man,v 1.9 2006/01/09 15:00:52 dawes Exp $
.\"
.TH XON 1 __vendorversion__
.SH NAME
xon \- start an X program on a remote machine
.SH SYNOPSIS
.B xon
remote-host [-access] [-debug] [-name window-name] [-nols] [-screen screen-no]
[-user user-name] [command ...]
.SH DESCRIPTION
.I Xon
runs the specified command (default xterm -ls) on the remote machine using
rsh, remsh, or rcmd.  Xon passes the DISPLAY, XAUTHORITY and
XUSERFILESEARCHPATH environment variables to the remote command.
.PP
When no command is specified, xon runs 'xterm -ls'.  It additionally
specifies the application name to be 'xterm-\fIremote-host\fP' and the
window title to be '-fIremote-host\fP'.
.PP
Xon can only work when the remote host will allow you to log in without a
password, by having an entry in the .rhosts file permitting access.
.SH OPTIONS
.PP
Note that the options follow the remote host name (as they do with rlogin).
.sp
.IP "\fB-access\fP"
Runs xhost locally to add the remote host to the host access list in the X
server.  This won't work unless xhost is given permission to modify the
access list.
.IP "\fB-debug\fP"
Normally, xon disconnects the remote process from stdin, stdout and stderr
to eliminate the daemon processes which usually connect them across the
network.  Specifying the \fB-debug\fP option leaves them connected so that
error messages from the remote execution are sent back to the originating
host.
.IP "\fB-name window-name\fP"
This specifies a different application name and window title for the default
command (xterm).
.IP "\fB-nols\fP"
Normally xon passes the -ls option to the remote xterm; this option
suspends that behaviour.
.IP "\fB-screen screen-no\fP"
This changes the screen number of the DISPLAY variable passed to the remote
command.
.IP "\fB-user user-name\fP"
By default, xon simply uses rsh/remsh/rcmd to connect to the remote machine
using the
same user name as on the local machine.  This option cause xon to specify an
alternative user name.  This will not work unless you have authorization to
access the remote account, by placing an appropriate entry in the
remote users .rhosts file.
.SH BUGS
Xon can get easily confused when the remote-host, user-name or various
environment variable values contain white space.
.PP
Xon has no way to send the appropriate X authorization information to the
remote host.
