.\" Copyright 1989, 1994, 1998  The Open Group
.\" 
.\" Permission to use, copy, modify, distribute, and sell this software and its
.\" documentation for any purpose is hereby granted without fee, provided that
.\" the above copyright notice appear in all copies and that both that
.\" copyright notice and this permission notice appear in supporting
.\" documentation.
.\" 
.\" The above copyright notice and this permission notice shall be included
.\" in all copies or substantial portions of the Software.
.\" 
.\" THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
.\" OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
.\" MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
.\" IN NO EVENT SHALL THE OPEN GROUP BE LIABLE FOR ANY CLAIM, DAMAGES OR
.\" OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
.\" ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
.\" OTHER DEALINGS IN THE SOFTWARE.
.\" 
.\" Except as contained in this notice, the name of The Open Group shall
.\" not be used in advertising or otherwise to promote the sale, use or
.\" other dealings in this Software without prior written authorization
.\" from The Open Group.
.\"
.\" $XFree86: xc/programs/xlsatoms/xlsatoms.man,v 1.10 2006/01/09 15:01:35 dawes Exp $
.\"
.TH XLSATOMS 1 __vendorversion__
.SH NAME
xlsatoms - list interned atoms defined on server
.SH SYNOPSIS
.B xlsatoms
[-options ...]
.SH DESCRIPTION
.I Xlsatoms
lists the interned atoms.  By default, all atoms starting from 1 (the lowest
atom value defined by the protocol) are listed until unknown atom is found.
If an explicit range is given, \fIxlsatoms\fP will try all atoms in the range,
regardless of whether or not any are undefined.
.SH "OPTIONS"
.PP
.TP 8
.B \-display \fIdpy\fP
This option specifies the X server to which to connect.
.TP 8
.B \-format \fIstring\fP
This option specifies a \fIprintf\fP-style string used to list each atom
\fI<value,name>\fP pair, printed in that order (\fIvalue\fP is an \fIunsigned
long\fP and \fIname\fP is a \fIchar *\fP).  \fIXlsatoms\fP will supply a
newline at the end of each line.  The default is \fI%ld\\t%s\fP.
.TP 8
.B \-range \fI[low]-[high]\fP
This option specifies the range of atom values to check.  If \fIlow\fP is not
given, a value of 1 assumed.  If \fIhigh\fP is not given, \fIxlsatoms\fP will
stop at the first undefined atom at or above \fIlow\fP.
.TP 8
.B \-name \fIstring\fP
This option specifies the name of an atom to list.  If the atom does not 
exist, a message will be printed on the standard error.
.PP
.SH "SEE ALSO"
X(__miscmansuffix__), Xserver(1), xprop(1)
.SH ENVIRONMENT
.TP 8
.B DISPLAY
to get the default host and display to use.
.SH AUTHOR
Jim Fulton, MIT X Consortium
